/*
IR receiver readout part of a sketch created by: Sam leong 2011-9-17 Email: b2cqshop@gmail.com
Modified and commented by Rudy Schlaf 2/2014 for the Make Course: www.makecourse.com
*/


#include <Wire.h> 
#include <LiquidCrystal_I2C.h>


#define IR_IN  11  //Infrared receiver output Pin
LiquidCrystal_I2C lcd(0x27,16,2);//instantiate a 16x2 I2C LCD display with address 0x27
int Pulse_Width=0;//variable used to store the determined pulse lengths 

//Variables that hold the transmitted data
unsigned int addressCode=0x00;// User-coded values
unsigned char commandCode=0x00;//Command code
unsigned char inverseCommandCode=0x00;//Anti-code command

/*******************************set-up function********************************************/

void setup()
{

  pinMode(IR_IN,INPUT);//Set the infrared receiver input pin
  // start serial port at 9600 bps:
  lcd.init();                      // initialize the lcd 
  lcd.backlight();
  Serial.begin(9600);
}

/***********************************main loop**********************************************/

void loop()
{  
  initializeTimerRegisters();//Timer initialization
  while(1)//loop that runs forever
  {
    determineIfThereIsA_Transmission();  //Decode the transmission if there is one; note that this process will take a bit longer than 100ms even if there is no transmission
                                         //i.e. the loop is slowed down dramatically!
                                         //there is a much better way to do it using interrupts...
                                         //this sketch is mainly for 'educational purposes' to learn how the remote communicates with the Arduino.
    sendDataToSerial();   //send decoding results to Serial port and LCD
  }  
}
