void determineIfThereIsA_Transmission(void)//This function checks if there is the 9 ms and the 4.5 ms feature of the transmission, and if they are
                                           //it calls the function that evaluates the bits (writeBitValuesIntoDataVariables())
{
  TCNT1=0X00;      //TCNT1 is the register for Timer 1 that the Arduino uses for storing the Timer time. 
  while(digitalRead(IR_IN))//this loop runs as long as the input pin is high - when there is no IR transmission, the pin is high. All transmissions start with a 9 ms low burst ("AGC signal")
  {
    if(TCNT1>=1563)  //When the high lasts longer than 100ms, we assume nothing is transmitted - sort of a 'time out'; (16000000 Hz/1024 prescaler factor)/10Hz=1562.5 (= 100ms)
    {
      addressCode=0XFF;
      return;//exit function and go back to main loop
    }  
  }

  //if we end up here the function was entered while the signal is low on the input - a transmission started.
  
  TCNT1=0X00;//reset timer to 0

  while(!(digitalRead(IR_IN))); //wait until the signal goes high
  Pulse_Width=TCNT1;//at this point in time the timer TCNT1 register contains the length of the current pulse.
                    //If there is a transmission starting the pulse width should be now 9 ms.
  TCNT1=0;//set timer back to zero before we evaluate the pulse. This enables to measure the following pulse accurately, even if we evaluate the last pulse...
  //evaluate the previous pulse length
  if(Pulse_Width>=140&&Pulse_Width<=142)//if the pulse is 9ms long then look for further pulses and decode the transmission; all transmission start with a 9 ms start pulse
  {

    while(digitalRead(IR_IN));//wait until the pin goes low. 
    Pulse_Width=TCNT1;//after the wait TCNT1 contains the pulse length
    TCNT1=0;//resent timer to zero
    if(Pulse_Width>=68&&Pulse_Width<=72)//if the pulse was 4.5ms then the bits of the transmission will follow. All transmisisons have a 4.5 ms high 'space' after the intitial 9 ms low pulse. 
    {  
      writeBitValuesIntoDataVariables();//this function reads in the bits that follow the 4.5 ms high pulse.
      return;//we got the data, now back to the main loop
    }
    else if(Pulse_Width>=34&&Pulse_Width<=36)//if the pulse was 2.25ms then we are receiving a 'repeat' signal, i.e. the button is still pressed after the data transmission was completed the first time.
    {
      while(!(digitalRead(IR_IN)));//wait as long the input is low
      Pulse_Width=TCNT1;//measure the pulse length
      TCNT1=0;//reset timer
      if(Pulse_Width>=7&&Pulse_Width<=10)//after the 2.25 ms low comes a 560us high, if we measure 560us, then return to the main loop
      {
        return; 
      }
    }
  }
}


